# Kagera Router Management Utility

This is the Kagera Build Environment. It is heavily based on OpenWrt's Build
Environment and heavily uses Bootstrap for all Kagera related actions.

Kagera Firmware is an effort aimed at building a powerful software helping to
solve a number of different problems in current home routers and to extend SOHO
devices capabilities. It aims to solve the problem of excessive buffering of
network packets, as it is much easier to start addressing the problem at the
home router end. Beyond this, Kagera aims to be a modular router management
utility, that enables experiments with "next generation" Internet features,
such as DualBand WiFi, IPv6 and DNSSEC.

Kagera is built atop the OpenWrt project, which has great Linux kernel support
for many embedded devices, bringing its strengths and opens a whole new world
of possibilities. The modular design with support of external root lets user to
flash just the core system and then choose which  functionality does he really
need, decreasing necessary free space and the number of available firmware
editions. What is more, Kagera Firmware implements the online updates feature,
and therefore allows network administrators to easily upgrade software directly
from the router configuration page.

Bringing these strenghts together opens a whole new world of possibilities.


# Kagera Installation

This is the Kagera Build Environment, that allows to easily compile the Firmware
and produce final, ready to flash images. The following commands might be find
to be usefull, while building the Kagera.

Cleaning targets:

* make clean              - cleans just the packages for the current
                              configuration. This will keep .config in tact.
* make distclean          - cleans whole environment including the type of
                              architecture. This will remove .config file as
                              well as the build directory.
* make mrproper           - same as `make distclean`.

Configuration targets:

* make config             - this will provide a legacy, console-based
                              interface to configure Kagera Build Environment.
* make menuconfig         - this will provide a 'graphical' interface to
                              select Kagera specific options such as target
                              architecture or OpenWrt version.
* make nconfig            - this will provide an anternative 'graphical'
                              interface to select Kagera specific options.
* make oldconfig          - updates current config utilising a .config file
                              privided by user as a base
* make kernel_menuconfig  - this will launch a modern 'graphical' interface,
                              that allows to customize a set of options
                              available in Linux Kernel used with Kagera.
* make openwrt_menuconfig - if it is necessary to modify which packages
                              the target image should contain, add a few
                              utilities or libraries, this command will
                              allow to alter default OpenWrt configuration.

Generic targets:

* make all                - builds all selected target images
* make world              - `make all` equivalent

Other targets:

* make board              - shows information about target architecture and
                              board(s), the final images are being built for
* make help               - displays this help
* make version            - shows the version of Kagera Firmware being built


To build your own firmware, you need to have access to a *BSD, Linux or Mac OSX
operating system. Windows and Cygwin is not supported because of the lack of
case sensitiveness in the file system.
